Skip to main content
`Ctrl`+`K`

# PetscSFFetchAndOpEnd

end operation started in matching call to `PetscSFFetchAndOpBegin()` or `PetscSFFetchAndOpWithMemTypeBegin()` to fetch values from roots and update atomically by applying operation using `leafdata`

## Synopsis

    #include "petscsf.h"
    PetscErrorCode PetscSFFetchAndOpEnd(PetscSF sf, MPI_Datatype unit, void *rootdata, const void *leafdata, void *leafupdate, MPI_Op op)

Collective

## Input Parameters

- sf - star forest

- unit - data type

- leafdata - leaf values to use in reduction

- op - operation to use for reduction

## Output Parameters

- rootdata - root values to be updated, input state is seen by first process to perform an update

- leafupdate - state at each leaf’s respective root immediately prior to atomic update

## See Also

PetscSF - an alternative to low-level MPI calls for data communication, `PetscSF`, `PetscSFComputeDegreeEnd()`, `PetscSFReduceEnd()`, `PetscSFSetGraph()`, `PetscSFFetchAndOpBegin()`, `PetscSFFetchAndOpWithMemTypeBegin()`

## Level

advanced

## Location

src/vec/is/sf/interface/sf.c

## Examples

src/vec/is/sf/tutorials/ex1.c

## Implementations

PetscSFFetchAndOpEnd_Allgatherv() in src/vec/is/sf/impls/basic/allgatherv/sfallgatherv.c
PetscSFFetchAndOpEnd_Basic() in src/vec/is/sf/impls/basic/sfbasic.c
PetscSFFetchAndOpEnd_Window() in src/vec/is/sf/impls/window/sfwindow.c

Index of all PetscSF routines
Table of Contents for all manual pages
Index of all manual pages